package cat.hack3.codingtests.marsrover;

public class MarsRover {
    private final MarsMap marsMap;
    private final Coordinates currentCoordinates;
    private MarsMap.Direction currentDirection;

    public MarsRover(MarsMap marsMap, Coordinates startingCoordinates, MarsMap.Direction startingDirection) {
        this.marsMap = marsMap;
        currentCoordinates = startingCoordinates;
        currentDirection = startingDirection;
    }

    public Coordinates moveForward() {
        return currentCoordinates.updatePositionTowards(currentDirection);
    }

    public MarsMap.Direction turnLeft() {
        currentDirection = marsMap.changeDirectionToLeft(currentDirection);
        return currentDirection;
    }

    public Coordinates getCurrentCoordinates() {
        return currentCoordinates;
    }

    public MarsMap.Direction getCurrentDirection() {
        return currentDirection;
    }
}
